//+------------------------------------------------------------------+
//|                                                          i_hist  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Bookkeeper"
#property link      "yuzefovich@gmail.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 ForestGreen 
#property indicator_color2 Red

extern int SeniorPeriod=1; // =1 (H1)
                           // =2 (H4)
                           // =3 (D1)

double GreenBuffer[];
double RedBuffer[];

string smbl[14]={
                 "GBPUSD",
                 "EURGBP",
                 "GBPCHF",
                 "CHFJPY",
                 "AUDJPY",
                 "EURJPY",
                 "USDCHF",
                 //------
                 "NZDJPY",
                 "AUDUSD",
                 "USDJPY",
                 "EURUSD",
                 "EURCHF",
                 "GBPJPY",
                 "NZDUSD"
                };
double smbl_movement[14]={0,0,0,0,0,0,0,0,0,0,0,0,0,0};
int smbl_N_sort[14]={0,0,0,0,0,0,0,0,0,0,0,0,0,0};
double smbl_movement_sort[14]={0,0,0,0,0,0,0,0,0,0,0,0,0,0};

//+------------------------------------------------------------------+
int deinit()
{
   Comment("");
   return(0);
}
//+------------------------------------------------------------------+
int init()
{
   IndicatorBuffers(6);
   SetIndexStyle(0,DRAW_LINE,EMPTY,2);
   SetIndexStyle(1,DRAW_LINE,EMPTY,2);
   SetIndexBuffer(0,GreenBuffer);
   SetIndexBuffer(1,RedBuffer);
   string prd;
   if(SeniorPeriod==1) prd="H1";
   if(SeniorPeriod==2) prd="H4";
   if(SeniorPeriod==3) prd="D1";
   IndicatorShortName("Profit( "+prd+" )");
   return(0);
}
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int start()
{
   int SeniorTF;
   if(SeniorPeriod==1) SeniorTF=60;
   else
   {
      if(SeniorPeriod==2) SeniorTF=240;
      else SeniorTF=1440;
   }
   int ExtCountedBars=IndicatorCounted();
   if(ExtCountedBars<0) return(-1);
   if(ExtCountedBars>0) ExtCountedBars--;
   int limit=Bars-ExtCountedBars-1;
   if(limit>Bars-SeniorTF) limit=Bars-SeniorTF;
   if(limit>5000) limit=5000;
   for(int i=0; i<limit; i++)
   {
      double sumbuy=0, sumsell=0;
      datetime timenow=iTime("EURUSD",PERIOD_M1,i);//    (?)
      datetime timestart=iTime("EURUSD",PERIOD_M1,i+SeniorTF);
      for(int j=0; j<14; j++)
      {
         int q;
         if(j<7) q=-1; else q=1;
         string sm=smbl[j];
         int ii=iBarShift(sm,PERIOD_M1,timenow);
         int jj=iBarShift(sm,PERIOD_M1,timestart);
         double p;
         if(StringFind(sm,"JPY")>=0) p=0.01; else p=0.0001;
         double sp=MarketInfo(sm,MODE_SPREAD);
         double pp=MarketInfo(sm, MODE_TICKVALUE);
         double mv=((iClose(sm,PERIOD_M1,ii)-iClose(sm,PERIOD_M1,jj))/p*q-sp)*pp;
         smbl_movement[j]=mv;
         if(j<7) sumsell=sumsell+smbl_movement[j];
         else sumbuy=sumbuy+smbl_movement[j];
      }
      GreenBuffer[i]=sumbuy;
      RedBuffer[i]=sumsell;
      if(i==0 && SeniorPeriod==2)
      {
         for(ii=0; ii<14; ii++)
         {
            smbl_N_sort[ii]=ii;
            smbl_movement_sort[ii]=smbl_movement[ii];
         }
         double MaxProfit=-100000, prevMaxProfit=100000;
         jj=0;
         int lmt=0;
         for(lmt=0;lmt<14;lmt++)
         {
            for(ii=0;ii<14;ii++)
            {
               if(smbl_movement_sort[ii]>=MaxProfit && smbl_movement_sort[ii]<=prevMaxProfit)
               {
                  jj=ii;
                  MaxProfit=smbl_movement_sort[ii];
               }
            }
            prevMaxProfit=MaxProfit;
            MaxProfit=-100000;
            smbl_N_sort[lmt]=jj;
            smbl_movement_sort[jj]=prevMaxProfit+1;
            jj=0;
         }
         string strcom="";
         for(jj=0;jj<14;jj++)
         {
            ii=smbl_N_sort[jj];
            strcom=strcom+smbl[ii]+" "+DoubleToStr(smbl_movement[ii],2)+"\n";
         }
         Comment(strcom);
      }
   }
   return(0);
}
//+------------------------------------------------------------------+